--[[ ###         Pistol Shot Warthog Entry for Phasor v2           ###]]--
--[[ ### by H® Shaft, Wizard, Nugget, Kennan, Shaft & Elite Prime  ###]]--

vehicles = {}

function GetRequiredVersion()
	return 200
end

function OnScriptLoad(process, game, persistent)
	LoadTags()
end

function OnNewGame(map)

end

function OnDamageLookup(receiving, causing, tagid, tagdata)
	if receiving ~= nil and causing ~= nil and receiving ~= causing then
		if tagid == pistolshot_tag_id then
			local mapId2 = readdword(getobject(receiving))
			if mapId2 == rwarthog_tag_id or mapId2 == warthog_tag_id then
				local driver, passenger, gunner
				local player = objectidtoplayer(causing)
				
				for k,v in pairs(vehicles) do
					if vehicles[k].vehiId == receiving then
						if vehicles[k].seat == 0 then driver = true end
						if vehicles[k].seat == 1 then passenger = true end  
						if vehicles[k].seat == 2 then gunner = true end
					end
				end
				
				if not isinvehicle(player) then
					if not driver then
						entervehicle(player, receiving, 0)
					elseif not gunner then
						entervehicle(player, receiving, 2)
					elseif not passenger then
						entervehicle(player, receiving, 1)
					end
				end
				
			end
		end
	end
	return nil	
end

function OnVehicleEntry(player, veh_id, seat, mapId, relevant)
	vehicles[player] = {}
	vehicles[player].vehiId = veh_id
	vehicles[player].seat = seat
	return nil
end

function OnVehicleEject(player, relevant)
	vehicles[player] = nil
	return nil
end

function LoadTags()
	rwarthog_tag_id = gettagid("vehi", "vehicles\\rwarthog\\rwarthog")
	warthog_tag_id = gettagid("vehi", "vehicles\\warthog\\mp_warthog")
	pistolshot_tag_id = gettagid("jpt!", "weapons\\pistol\\bullet")
end

-- Thanks to H® BugZ, Oxide, Elite Prime, Nugget & Wizard & many others for their contributions to Phasor and the Halo Community.  Special Thanks to Elite Prime for added assistance.
-- Visit Elite Prime's pastebin account for for some expert scripts: http://pastebin.com/u/eliteprime.  Visit mine (H® Shaft) at http://pastebin.com/u/HR_Shaft for updates.